#include <iostream>
#include <fstream>
#include "ANN.h"

using namespace std;

/*ANN::ANN(const vector<int>&layout, const vector<double>&weights)
{
	//Determine number of layout weights:
	unsigned int w = 0;
	for (unsigned int i=0;i<layout.size()-1;i++) {
		matrix_position.push_back(w);
		w += layout[i]*layout[i+1];
	}
	layout_weights = w;		

	//Determine number of hidden nodes:
	layout_nodes = 0;
	for (unsigned int i=1;i<layout.size()-1;i++) {
		layout_nodes += layout[i];
	}

//	cout << "Number of weights: " << weights.size() << endl;
//	cout << "Layout number of weights: " << layout_weights << endl;
//	cout << "Layout hidden nodes: " << layout_nodes << endl;

	this->layout = layout;
	this->weights = weights;
}*/
ANN::ANN()
{
}
//ANN::ANN(int nHidden, int nOutputs) //TODO: rewrite the constructor function according to the parametres
ANN::ANN(int nInputs, int nFeatures, int nOutputs, int nrH, int nrV, double _x0, double _y0, double d, double fC ) //nOutputs = |actions| + |values| = |actions| +1
{  
    ofstream kk;
    //vector<double> layer1();
    layer2 = new vector<double>(nFeatures, 0.0);
    //layer2 = new vector();
    layer3 = new vector<double>(nFeatures, 0.0);
    layer4 = new vector<double>(nOutputs, 0.0);
    //layer4 = new vector<double>();
    weights = new vector<double>(nFeatures*nOutputs, 0.0);
    DIST = d;
    firstC = fC;
    outputs = nOutputs;

    nVerticals = nrV;
    nHoriz = nrH;
    x0=_x0;
    y0=_y0;
    kk.open("kk.txt", ios::out|ios::app);
    kk << "ANN created with"<< endl;
    kk << "Inputs=" << nInputs << endl;
    kk << "Features=" << nFeatures << endl;
    kk << "nOutputs=" << nOutputs << endl;
    kk << "nrH=" << nrH << endl;
    kk << "nrV=" << nrV << endl;
    kk << "DIST=" << d << endl;
    kk << "-------------" << endl;
    kk.close();
    //vector<double> outputs(nOutputs, 0.0);
    //cout << "ANN constructor: "<< layer4.size()<< endl;

    /*
    for(int i=0 ; i < layer3->size(); i++)
    {
    	weights->at(i*layer4->size()+layer4->size() - 1) = 1.0;
    }*/
}

int ANN::computeANN(double inputs[], int nrofOutputs) //returns error if the position is illegal
{
    double sum=0;
    double aux;
    double c1,c2;
    ofstream myfile;

    myfile.open("myfile.txt", ios::out|ios::app);

    c2=-DIST;
    //cout << "layer2 size = " <<layer2->size() << endl;
    /*myfile << "nHoriz=" << nHoriz << endl;
    myfile << "DIST=" << DIST << endl;
    myfile << "aux=" << aux << endl;
    myfile << "C1=" << c1 << endl;
    */
    for(unsigned int i=0; i< layer2->size(); i++)
    {
    	if(i % nHoriz == 0)
    	{
    		aux = nHoriz*DIST;
    		c1 = START;
    		c2 = c2+DIST;
    	}
        aux = rbf(inputs, c1, c2);
        layer2->at(i) = aux;
        //myfile << "POS="<< inputs[0]<<","<<inputs[1]<<","<<inputs[2]<<" C="<< c1<<"," <<c2<< " Value="<< aux << endl;
        //if( aux > 0)
          //  myfile << i <<"=i p[" << inputs[0] << "," << inputs[1] << "," << inputs[2] << "] to c["<< c1 <<","<< c2 << "] RBFValue="<< layer2->at(i) <<endl;
        sum = sum + layer2->at(i); //Sum of the nodes
        c1=c1+DIST;
        
    }
    //cout << "------------------------------------------"<< endl;
    myfile.close();
    //cout << "layer3" << endl;
    //Normalized layer
    for(unsigned int i=0; i< layer2->size() ; i++)
    {
        //layer3[i] = layer2[i]/sum;
        layer3->at(i)=layer2->at(i);
        //if(layer3->at(i))
            //cout << layer3->at(i)<<endl;
    }
    //cout << "layer4" << endl;
    //Ouput layer
    for(unsigned int i=0; i< nrofOutputs; i++) //For each output
    {
        int index;
        aux = 0;
        for(int j=0; j< layer3->size(); j++) //each layer3
        {
            index = j * layer4->size() + i;    //Index of the weight, all the weights from one node are consecutive so the ouput node denotes the offset
            //cout << "index=" << index << endl;
            aux = aux + layer3->at(j)*weights->at(index);
        }
        layer4->at(i) = aux;
        //cout << "Output("<<i<<")="<<aux<<endl;
        //if(aux)
        //cout <<i<<"::output(i)="<< layer4->at(i) << endl;
    }
    //Computing value function
    aux = 0;
	for(int j=0; j< layer3->size(); j++) //each layer3
	{
		int index = (j+1) * layer4->size() -1;    //Index of the weight, all the weights from one node are consecutive so the ouput node denotes the offset
		//cout << "index=" << index << endl;
		aux = aux + layer3->at(j)*weights->at(index);
	}
	layer4->at(layer4->size()-1) = aux;

    //foo.close();
    //cout << "and out" << endl;
    return 0;
}


double ANN::getWeight(unsigned int layer, unsigned int from, unsigned int to)
{
	/*unsigned int start = matrix_position[layer];
	unsigned int cols = layout[layer+1];
//	cout << "weights.size(): " << weights.size() << "start: " << start << " cols: " << cols << " from: " << from << " to: " << to << " layer: " << layer <<  endl;
	return weights[start + from*cols + to];*/
    return 0;
}



double ANN::rbf(double position[], double c1, double c2)
{
    ofstream foo;
    foo.open("rbf.txt", ios::out|ios::app);
    //Compute the output of the RBF from the position and the center mapped to the neuron
    double hDist, res, sig;
    
    sig = DIST*1.42;
    hDist = horizontalDistance(position); //Projection of the vector (x,y) on a new vector x'
    res = exp(-(euDist(hDist,position[2],c1,c2))/(2*sig*sig));

    //foo << "["<< hDist <<","<<position[2]<<"]-->["<< c1 <<","<<c2 <<"]="<< res <<endl;

    foo.close();
    return res;
}
double ANN::horizontalDistance(double position[])
{
    //Returns the length of the vector between the original position and the new one on the horizontal plane
    double dir_x, dir_y, sign=1;

    //cout << "x0=" << x0 <<" y0="<<y0 <<"          px="<< position[0]<<" py=" << position[1] << endl; 
    dir_x = position[0]-x0;
    if( y0 < 0.00001 && y0 > -0.00001 ){
        //cout << "Bigger" << endl;     
        y0 = 0;
    }

    dir_y = position[1]-y0;
    if( dir_x < 0 || dir_y < 0 )
    	sign = -1;

    return sign * sqrt(pow(dir_x,2)+pow(dir_y,2));
}

double ANN::getValue()
{
    return layer4->at(layer4->size()-1);
}
double ANN::getPolicy(int pol)
{
    double aux;

    aux = layer4->at(pol);

    return aux;
}

double ANN::updateWeights(int output, double expected, double rate)
{
    double c1,c2;
    double update,error;
    double sum = 0;

    error = rate*(expected - layer4->at(output));

    for(int i = 0; i< layer3->size(); i++) //for each hidden node
    {
    	update = error * layer3->at(i);
        weights->at(i*layer4->size()+output) = weights->at(i*layer4->size()+output) + update;
        sum = sum + weights->at(i*layer4->size()+output)*layer3->at(i);
    }

    return sum;
}

double ANN::stepWeights(int output, int dir)
//TODO: remove
{
    double lRate=0.1;
    double c1,c2;
    double update,error;
    double sum=0;

    error = lRate*dir;

    for(int i = 0; i< layer3->size(); i++) //for each hidden node
    {
        update = error * layer3->at(i);
        update = weights->at(i*layer4->size()+output) + update;
        weights->at(i*layer4->size()+output) = update;
        sum = sum + update;
        //cout << "Update= " << update << endl;
    }
    return update;
}

double ANN::euDist(double x1, double x2, double c1, double c2)
{
    double t1,t2;
    t1 = x1-c1;
    t2 = x2-c2;
    t1=t1*t1;
    t2=t2*t2;
    if(sqrt(t1+t2) < 0.1 )
    {
    	//cout << "Point:["<<x1<<","<<x2<<"]" <<" Center:["<<c1<<","<<c2<<"]"<<endl;
    }
    return sqrt(t1+t2);
}

void ANN::updatePolicy(int policy, double tdError, double lRate)
//TODO: remove
{
    int nHid = layer3->size();
    int nOut = layer4->size();
    double aux;


    if(tdError > 0)
    {
        //Update fixed amount
        for(int i=0; i<nHid; i++)
        {
            aux = weights->at(i*nOut+policy) - (lRate*0.1)*layer3->at(i);
            weights->at(i*nOut+policy) = aux;
        }
    }else if(tdError < 0)
    {
        //Update fixed amount
        for(int i=0; i<nHid; i++)
        {
            aux = weights->at(i*nOut+policy) + (lRate*0.1)*layer3->at(i);
            weights->at(i*nOut+policy) = aux;
        }
    }
    //cout << "NewPol=" << weights->at(i*nOut+policy) << endl;
    /*if( tdError == -1){
        for(int i=0; i<layer4->size(); i++)
        {
            weights->at(i*nHid+policy) = -1;
        } 
    }else{
        for(int i=0; i<nHid; i++)
        {
            weights->at(i*nOut+policy) = weights->at(i*nOut+policy) + (lRate*tdError)/nHid;
        }
    }*/
}

int ANN::getGreedy()
//TODO: remove
{
    double max=0;
    int greedy=0;
    //cout << "Greedy" << endl;
    for(int i = 0; i< layer4->size()-1;i++)
    {
        //cout << "Greedy" << i << endl;
        if(layer4->at(i)>max)
            greedy = i;
    }
    return greedy;
}

int ANN::getOutputs()
//TODO: remove
{
    return layer4->size();
}

void ANN::dumpLayer(int layer)
{
    for(int i=0; i<layer3->size(); i++)
    {
        cout << layer3->at(i) << endl;
    }
}
int ANN::initialize(int nInput, int nHidden, int nOutputs, double position[4])
//TODO: remove
{
   /* x0 = position[0];
    y0 = position[1];

    /*for( int i=0; i<nInput; i++ )
    {
        inputs.push_back(0);
    }
    for( unsigned int i=0; i<(nHoriz*nVerticals); i++ )
    {
        layer2.push_back(0);
        layer3.push_back(0);
    }
    for( unsigned int i=0; i<((nHoriz*nVerticals) * nOutputs); i++ )
    {
        weights.push_back(0);
    }
    /*for( int i=0; i<nOutputs; i++ )
    {
        outputs.push_back(0);
    }*/

    return 1;
}

void ANN::dumpWeightsAll(int ep)
{

	ofstream w1,w2,w3;

    w1.open("out.txt", ios::out|ios::app);

    w1 << "Episode: " << ep << endl;

    for (int i =0; i < weights->size(); i++)
    {
    	w1 << weights->at(i) << endl;
    }
	w1.close();
}
void ANN::restoreWeights()
{
	ifstream w1;
	char inLine[128];
	double aux;
    int i;

	w1.open("weights.txt", ios::in);
	w1 >> inLine; //Episode
    w1 >> inLine;

	for(i =0; i< weights->size(); i++ )
	{
		w1 >> aux;
		weights->at(i) = aux;
        //cout << i <<" Restored:" << weights->at(i) <<endl;;
	}
    cout << "read:" << i << endl; 
}

void ANN::dumpWeights(int ep, int output )
{

	ofstream w1;

    w1.open("weights.txt", ios::out|ios::app);

    w1 << "Episode: " << ep << endl;

	for(int i=0; i<layer3->size(); i++)
	{
		w1 << weights->at(i*layer4->size()+output) << endl;
	}

	w1 << "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<" << endl;
	w1.close();


}

