#ifndef ANN_H
#define ANN_H
#define START -0.1

//#define H_FEATURES  20 //Move over to RL.h
//#define V_FEATURES  10

#include <vector>
#include <math.h>
using namespace std;

class ANN
{	
public:
    int inputs;
    int hidden;
    int outputs;
    int firstC;
private:
    
	vector<int> layout;
	
    vector<double> *layer1; // inputs
    vector<double> *layer2; // Hidden layer
    vector<double> *layer3; // Normalized layer
    vector<double> *layer4; // Actor-Critic output layer
    vector<double> *weights; //Weights
    
    double x0,y0,DIST;
    int nVerticals, nHoriz;

	
public:
    ANN();
    ANN(int nInputs, int nFeatures, int nOutputs, int nrH, int nrV, double x0, double y0, double d, double firstC ); //nOutputs = |actions| + |values| = |actions| +1
	//ANN(const vector<int> &layout, const vector<double> &weights);
	void getOutput(const vector<double> &inputs, vector<double> &outputs);
	double getWeight(unsigned int layer, unsigned int from, unsigned int to);

    int             initialize(int nInput, int nHidden, int nOutputs, double position[4]);
	//unsigned int    layoutNodes() {return layout_nodes;};
	//unsigned int    layoutWeights() {return layout_weights;};
    void            computeHidden(double position[4]);
    void            computeOutputs();
    double          rbf(double position[], double c1, double c2);
    double          horizontalDistance(double position[]);
    int             computeANN(double inputs[],int nrofOutputs);
    double          getValue();
    double          getPolicy(int pol);
    double          updateWeights(int output, double expected, double rate);
    double          stepWeights(int output, int dir);
    void            updateWeights2(int nrofoutput, double x, double expected);
    void            updateValue(double tdError, double lRate);
    void            updatePolicy(int policy, double tdError, double lRate);
    int             getGreedy();
    int             getOutputs();
    void            dumpLayer(int layer);
    double          differential(double x, double c);
    double          euDist(double x1, double x2, double c1, double c2);
    void 			dumpWeightsAll(int ep);
    void 			dumpWeights(int ep, int output);
    void 			restoreWeights();
};

#endif
