#include "Chassis.h"

Chassis::Chassis(dWorldID world):RAPrism(world)
{
}

Chassis::Chassis(dWorldID world, dReal width, dReal height, dReal depth, dReal mass):RAPrism(world, width, height, depth, mass)
{
}

void Chassis::addToViewer(Viewer *v)
{
	if (v==NULL)
		return;
	ISceneNode* node = v->getSceneManager()->addCubeSceneNode(1);
	dGeomSetData(geom, node);

	dReal* position = (dReal*)dGeomGetPosition(getGeom());
	node->setPosition(vector3df(position[0], position[1], position[2]));
	node->setScale(vector3df(dimensions[0], dimensions[1], dimensions[2]));

	node->setMaterialTexture(0, v->getVideoDriver()->getTexture("../media/checkered.ppm"));
	node->setMaterialFlag(video::EMF_LIGHTING, false);

	v->addObject(this->geom);
}
