#include <iostream>
#include <ode/ode.h>

#include "Simulator.h"
#include "Controller.h"
#include "RL.h"
#include  "testANN.h"
#include <fstream>
#include <time.h>

#define EPISODES    7500
#define STEPS		2000
#define INPUTS      1
#define OUTPUTS     2
#define VISUAL      0
#define DFILE       "heights.txt"
#define MODE		1 //0:FTL, 1:LEARNING, 2:S-shape, 3:replay
#define TIMESTEP	0.05
#define SIGNAL_FREQ	40


using namespace std;

// some constants
#define STARTZ 0.2	// starting height of chassis

double horizontalDistance(double position[]);
void tracing(char* trace_name, Train * t, int episodes, int steps, double position[]);
void heights(char* fname, Train *t, int episodes, double height, double maxH );

int main() {

    Simulator simulator(0, 0, STARTZ, TIMESTEP, VISUAL);
    int episodes, steps;
    int aux=0;
    ofstream w1, w2;
    double maxH=0.0,maxHT=0.0, aux1;
    int rep=0;
    double avgVector[10];

    RL foo(1, 0.01, 0.001, 1);
    //testANN *myTest;
    remove( DFILE );
    remove ("weights1.txt");
    remove ("weights2.txt");
    remove ("out.txt");
    remove("randoms.txt");
    remove("myfile.txt");
    remove("info.txt");
    
    //testANN(int in, int hid, int out, int height)
    // For ANN training
    //myTest = new testANN(INPUTS,(1+END-START)/DIST,1,1,DIST,START);

    // For CACLA training
    //myTest = new testANN(INPUTS,(1+END-START)/DIST,2,1,DIST,START);

    steps=0;
    episodes = 0;
    maxH = simulator.getTrain()->getHeight(0);
    simulator.getTrain()->setTimestep(TIMESTEP);

    srand ( time(NULL) );
 
    ofstream fHeight;
    struct tm *ctime;
    time_t now;
    time(&now);
    ctime = localtime(&now);


    char name[24];
    char trace_name[24];

    strftime(name, sizeof(name), "fHeight%m%d_%H%M.txt", ctime);
    strftime(trace_name, sizeof(trace_name), "trace%m%d_%H%M.txt", ctime);
//
//    name = "fHeight";
//    name += ctime->tm_mon;
//    name += ctime->tm_mday;
//    name += ctime->tm_hour;
//    name += ctime->tm_min;
//    name += "txt";


    foo.actions(5,simulator.getTrain());
    if( MODE == 3 )
    {
        foo.initialize();
        //foo.dumpweights(0);
    }

    int cd;
	double hdiff = 100;
	double auxkk = -100;
	while( auxkk < 0.078 || cd < 10 ){

		foo.actions(3,simulator.getTrain());
		simulator.step();
		foo.actions(4,simulator.getTrain());
		simulator.step();
		foo.actions(4,simulator.getTrain());
		simulator.step();
		foo.actions(3,simulator.getTrain());
		simulator.step();

		hdiff = abs( simulator.getTrain()->getHeight(0) - auxkk);
		auxkk = simulator.getTrain()->getHeight(0);

//                	cout << "Reseting:" << auxkk << " " << hdiff << " " << anglesR << endl;
		if( hdiff < 0.001)
			cd++;
		else
			cd = 0;
	}
	cout << "System initialized" << endl;


    while (simulator.running && episodes < EPISODES ) {
//    	cout << "Height at start of loop:" << simulator.getTrain()->getHeight(0) << endl;

        steps++;
        aux=0;
        
        //controller(simulator.getTrain(), simulator.getViewer());
        //controllerFTL(simulator.getTrain(), simulator.getViewer());
        //controllerR(simulator.getTrain(), simulator.getViewer());
        //controllerUp(simulator.getTrain(), simulator.getViewer());
        //controllerS(simulator.getTrain(), simulator.getViewer());
        
        if( MODE == 0)
        {
        	controllerFTL(simulator.getTrain(), simulator.getViewer());
        }else if( MODE == 1)
        {
        	foo.preStep(simulator.getTrain(),!steps%SIGNAL_FREQ);
        }else if( MODE == 2)
        {
        	controllerS(simulator.getTrain(), simulator.getViewer());
        }else if( MODE == 3)
        {
            foo.next(simulator.getTrain());
        }
        // Show sensor data 
        //std::cout << "Travelled distance: " << simulator.getTrain()->getTravelledDistance() << std::endl;
        //std::cout << "Wheel distance: " << simulator.getTrain()->getWheelDistance(simulator.getTimestep()) << std::endl;
        //std::cout << "Distance from nose: " << simulator.getTrain()->getDistanceNose((dGeomID)simulator.getStaticSpace()) << std::endl;
        //std::cout << "Sonar distance measurement: " << simulator.getTrain()->getSonar((dGeomID)simulator.getStaticSpace(), 0.1) << std::endl;
        //double up, down, left, right;
        //simulator.getTrain()->getJointForces(0, &up, &down, &left, &right);
        //std::cout << up << " " << down << " " << left << " " << right << std::endl;

        // Position camera in PIKo's head /
        double *position;
        position = (double *)simulator.getTrain()->getFirstModule()->chassis->getPosition();
        if(VISUAL)
        {
        	dVector3 forward;
            dBodyVectorToWorld(simulator.getTrain()->getFirstModule()->chassis->getBody(), -1, 0, 0, forward);
            simulator.getViewer()->positionCamera(position, forward);
        }

        // Step simulator forward /
        aux = simulator.getTrain()->getHeight(0);
        simulator.step();

        tracing(trace_name, simulator.getTrain(), episodes, steps, position);
    
        aux1 = simulator.getTrain()->getHeight(0);

		if( aux1 > maxH){
			maxH = aux1;
           // cout << "MaxH:" << maxH <<" episode:" << episodes << endl;
		}

		aux1 = simulator.getTrain()->getHeight(4);

		if( aux1 > maxHT){
			maxHT = aux1;
		}

		if( MODE == 1 )
        {
            if(simulator.getTrain()->getHeight(0) > 0.5)
		    {
			    //rep++;
		    }else rep=0;

		    if(rep > 3)
		    {
			    cout << "dumpweight out"<< endl;
			    return 0;
		    }

		    aux = foo.postStep(simulator.getTrain());

		    if(aux != 0 || steps == STEPS)
			{
				steps = 0;
				if(aux == 0 && maxH < 0.5)
				{

					episodes++;
					aux1 = simulator.getTrain()->getHeight(0);
					cout << aux1 << "  "<< maxH << endl;
					cout << "Reset (main):"<< episodes << endl;

					heights(name, simulator.getTrain(), episodes, aux1, maxH);

					foo.actions(5,simulator.getTrain());

				}

                int anglesR=1;
                auxkk = -100;
                int count=0;
                while( auxkk < 0.078 || cd < 10 || anglesR ){

                	foo.actions(3,simulator.getTrain());
					simulator.step();
					foo.actions(4,simulator.getTrain());
					simulator.step();
					foo.actions(4,simulator.getTrain());
					simulator.step();
					foo.actions(3,simulator.getTrain());
					simulator.step();

					hdiff = abs( simulator.getTrain()->getHeight(0) - auxkk);
					auxkk = simulator.getTrain()->getHeight(0);
					anglesR = foo.anglesReseted(simulator.getTrain());

					if( hdiff < 0.001)
                		cd++;
                	else
                		cd = 0;

                	if(auxkk > 0.078 && cd >= 10 ){
                		count++;
                		if(count >5)
                		{
                			foo.actions(5, simulator.getTrain());
                			count = 0;
                			simulator.step();
                			cout << "reReseted" << endl;
                		}
                	}

				}
                maxH = aux;
			}
        }
    }
    foo.dumpweights(episodes, 0);

    fHeight.close();
    w1.close();
    w2.close();
	return 0;
}

double horizontalDistance(double position[])
{
    //Returns the length of the vector between the original position and the new one on the horizontal plane
    double dir_x, dir_y, sign=1;

    //cout << "x0=" << x0 <<" y0="<<y0 <<"          px="<< position[0]<<" py=" << position[1] << endl;
    if( (position[0] < 0) || (position[1] < 0) )
    	sign = -1;
    //cout << "dir_y: " << dir_y << "y0: " << y0 << endl;
    return sign * sqrt(pow(position[0],2)+pow(position[1],2));
}

void tracing(char* trace_name, Train *t, int episodes, int steps, double position[] )
{
	ofstream trace;
    trace.open(trace_name, ios::out|ios::app);

	trace << STEPS*episodes+steps << " " << horizontalDistance(position) << " "<< t->getHeight(0) << " ";
	trace << t->getJointAngle(0,1) <<" ";
	trace << t->getJointAngle(1,1) <<" ";
	trace << t->getJointAngle(2,1) <<" ";
	trace << t->getJointAngle(3,1) << endl;

    trace.close();
}
void heights(char* fname, Train *t, int episodes, double height, double maxH )
{
	ofstream fHeight;
    fHeight.open(fname, ios::out|ios::app);

    fHeight << episodes<< " "	<< height <<" " << maxH << " "<< t->getJointAngle(0,1) <<" " ;
	fHeight << t->getJointAngle(1,1)<<" " << t->getJointAngle(2,1)<<" ";
	fHeight << t->getJointAngle(3,1) << endl;

	fHeight.close();
}
