#ifndef OBJECT_H
#define OBJECT_H

#include <ode/ode.h>
#include "Viewer.h"

#ifdef _MSC_VER
#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
#endif

class Object
{
protected:
	dBodyID body;
	dGeomID geom;

public:
	Object(){};
	Object(dBodyID, dGeomID);
	virtual ~Object();
	dBodyID getBody();
	dGeomID getGeom();
	
	void addToSpace(dSpaceID);

	virtual void setPosition(dReal x, dReal y, dReal z);
	virtual void setRotation(const dMatrix3 R);
	virtual const dReal * getPosition();
	virtual const dReal * getRotation();
	virtual const dReal * getLinearVel();
	virtual const dReal * getAngularVel();
	
	virtual void addToViewer(Viewer *v) = 0;
};

#endif
