#include "ANN.h"
#include "Train.h"
#include <time.h>
#include <iostream>
#include <fstream>
#include <queue>
#define H_FEATURES  5 //5
#define V_FEATURES  5 //3
#define DIST		0.1
#define N_ACTIONS   4
#define POL_RATE    0.0001
#define VAL_RATE    0.001

using namespace std;

class RLEvent{
    public: 
        double dist, hor, vert;
      
        RLEvent(double dist, double hor, double vert){
	        this->dist = dist;
	        this->hor = hor;
	        this->vert = vert;
        }
};

class RL{
    private:
        ANN *network;
        int id;
        double policy[4][H_FEATURES*V_FEATURES];
        double oldValue, maxHeight, Vt, oldHeight;
        double speed,step;
        int pstep;
        double oldpos[3];
        double action1,action2;
        int nOutputs;
        double alfa, beta, reward, gamma; //alfa= Actor's learning rate, beta=Critic's learning rate, gamma=?
        ofstream myfile;
        bool exploratory[4];
        double angles[4];
        double milestone;
        int activeJoints;
        int chapter;

     //   queue<Event> ftl_events[5]; //Length equal to (#piko-elements - 1)
       
    public:
        int greedy, expl;
        double rate;

        RL(int _id, double valRate, double polRate, double rew);
        void 	blabla();
        void 	getOutput();
        void 	preStep(Train *t, bool keep);
        void 	actions(int action, Train *t);
        void 	nextActions(Train *t, double greedy1, double greedy2);
        int 	postStep(Train *t);
        int 	postStep_old(Train *t);
        void 	getnOutputs();
        double 	randDouble(double low, double high);
        double 	gaussianGenerator(double mu, double sigma);
        void 	dumpweights(int ep, int output);
        int  	signum(double a, double b);
        double 	vertical(Train *t);
        void 	nextActions6(Train *t, double greedy1, int joint);
        void 	refreshAngles(Train *t);
        void    next(Train *t);
        void    initialize();
        int 	anglesReseted(Train *t);
        void 	actionAngle(Train *t, int joint, double a, bool keep);
};
