#ifndef SIMULATOR_H
#define SIMULATOR_H

#include <ode/ode.h>
#include <iostream>
#include <fstream>

#include "Train.h"
#include "Vent.h"
#include "EATestVentStruct.h"
#include "StatBox.h"
#include "Viewer.h"
#include <time.h>

class Simulator
{
	private:
		Viewer *viewer;
		Train *train;
		double timestep;

		ofstream logfile;

		// dynamics and collision objects
		dSpaceID space;
		dGeomID ground;
		dSpaceID actor_space, static_space;

		EATestVentStruct *vents;
		StatBox* box1,*box2;
		bool visual;
        clock_t time;

	public:
		Simulator(dReal pos_x, dReal pos_y, dReal pos_z, double timestep, bool visual);
		~Simulator();

		void step();

		bool running;

		Train *getTrain() { return train; }
		Viewer *getViewer() { return viewer; }
		dSpaceID getStaticSpace() { return static_space; }
		double getTimestep() { return timestep; }
		bool getVisual(void) { return visual; }
		void newTrain(dReal pos_x, dReal pos_y, dReal pos_z, bool visual);
};

#endif
