#ifndef STATOBJECT_H
#define STATOBJECT_H

#include <ode/ode.h>
#include "Viewer.h"

#ifdef _MSC_VER
#pragma warning(disable:4244 4305)  // for VC++, no precision loss complaints
#endif

class StatObject
{
protected:
	dGeomID geom;

public:
	StatObject(){};
	StatObject(dGeomID);
	virtual ~StatObject();
	dGeomID getGeom();
	
	void addToSpace(dSpaceID);

	virtual void setPosition(dReal x, dReal y, dReal z);
	virtual void setRotation(const dMatrix3 R);
	virtual const dReal *getPosition();
	virtual const dReal *getRotation();
	
	virtual void addToViewer(Viewer *v) = 0;
};

#endif
