#ifndef VENT_H
#define VENT_H

#include "StatObject.h"

#define VENT_SCALE 0.0025		//scales the vent model to unit size in ODE
#define VENT_THICKNESS 0.025		//thickness of vent walls in normalized scale

class Vent : public StatObject
{
protected:
	IAnimatedMeshSceneNode *node;	//drawing node
	dGeomID collisionGeoms[4];	//The object is made up of 4 collision geometries
	int type;			//Determines wether type (I-,L- and T-vent) of the vent
	dReal scalex,scaley,scalez;	//Enables scaling of the vent along its axis

public:
	Vent(int type);
	Vent(int type, dReal scalex, dReal scaley, dReal scalez);

	void setPosition(dReal x,dReal y, dReal z);
	void setRotation(const dMatrix3 R);

	void addToSpace(dSpaceID);

	void addToViewer(Viewer *v);
};

#endif
