#ifndef VENTSTRUCT_H
#define VENTSTRUCT_H

#include "StatObject.h"
#include "Vent.h"

#define NUM_PARTS 9

//A structure built up usinge simple vent segments
class VentStruct : public StatObject
{
protected:
	Vent* vents[NUM_PARTS];
	dVector3 relPos[NUM_PARTS];					//stores the relative positions of each separate vent in the structure space
	dMatrix3 relRot[NUM_PARTS];					//stores the relative rotations of each separate vent in the structure space

public:
	VentStruct();
	
	void setPosition(dReal x,dReal y, dReal z);
	void setRotation(const dMatrix3 R);

	void addToSpace(dSpaceID);

	void addToViewer(Viewer *v);
};

#endif
