// Class for checking the ANN is working
// Uses random inputs to approximate the cross function
#include "testANN.h"


testANN::testANN(int in, int hid, int out, int height, double dist, double firstC)
{
    ofstream kk;
    //ANN(int nInputs, int nFeatures, int nOutputs, int nrH, int nrV, double _x0, double _y0, double d )
    myANN = new ANN(in,hid,out,hid/height,height,0,0, dist, firstC);
    old=0;

    kk.open("kk.txt", ios::out|ios::app);
    kk << "testANN created with:" << endl;
    kk << "Inputs=" << in << endl;
    kk << "Outputs=" << out << endl;
    kk << "Hidden nodes=" << hid << endl;
    kk << "Height=" << height << endl;
    kk << "----------" << endl;
    kk.close();
}

void testANN::stepCACLA(double x, int print)
{
    double pol,val,y,factor;
    double pos[2]={0,0};
    double tdE, reward, gamma; //tdE: TD-error; gamma: discount factor
    ofstream foo;
    
    foo.open("kk.txt", ios::app|ios::out);
    pos[0]=x;
    //Get policy
    pol = myANN->getPolicy(0);
    
    //Compute and get value
    if( pol > 0)
        myANN->stepWeights(1,1);
    else if(pol < 0)
        myANN->stepWeights(1,-1);

    myANN->computeANN(pos);
    val= myANN->getValue();
    
    //Evaluate value
    //y = cross(x);
    y = func2(x);//2x
    //y = func3(x); //sin(x)
    //y = func4(x);//3x
    
    tdE = reward + gamma*val-old;


    factor = val/y;

    //Update policy
    if( factor < 0)
    {
         //We decrease the policy in the same direction
        if (pol < 0)
            myANN->stepWeights(0,1);
        else if(pol > 0)
            myANN->stepWeights(0,-1);
    }else if( abs(factor-1) < abs(old-1) ) // The fitness has increased
    {
        //We increase the policy in the same direction
        if (pol < 0)
            myANN->stepWeights(0,-1);
        else if(pol > 0)
            myANN->stepWeights(0,1);
    }else if(abs(factor-1) > abs(old-1)) // The fitness has decreased
    {
        //We decrease the policy in the same direction
        if (pol < 0)
            myANN->stepWeights(0,1);
        else if(pol > 0)
            myANN->stepWeights(0,-1);
    }
    foo << "Episode="<< print <<" \t x=" << x <<" \t\tValue=" << old << " \t\t\tExpected=" <<y << " \t\t\tfactor=" << factor <<endl;
    foo.close();
    
    //Updates 'old' with this steps' value
    old=val;
}

void testANN::step(double x, int print)
{
    double resN, resC;
    double pos[2]={0,0};
    double pol,dif;
    double td1, td2;
    ofstream foo;
    foo.open("kk.txt", ios::app|ios::out);

    //Reveives x, needs to approximate y
    pos[0] = x;
    myANN->computeANN(pos);
    old = myANN->getValue();
    //Perform action
    resC = cross(x);
    //resC = func2(x);//2x
    //resC = func3(x); //sin(x)
    //resC = func4(x);//3x
    
    dif=abs(old/resC);

    foo << "Episode="<< print <<" \t x=" << x <<" \t\tValue=" << old << " \t\t\tExpected=" <<resC << " \t\t\tRelDif=" << dif <<endl;
    
    //Adjust weights
    myANN->updateWeights(0, resC);
    foo.close();
    //cout << "pol="<<pol << endl;
    /*if(pol<0)
    {
        myANN->updateValue(0.1, 0.1);
    }else if(pol>0)
    {
        myANN->updateValue(-0.1, 0.1);
    }
    myANN->computeANN(pos);
    resN = myANN->getValue();
    
    //cout << "old=" <<old << " new="<< resN << endl;
    /*td1 = resC-old; 
    td2 = resC-resN;
    dif = abs(td1) - abs(td2);
    */
    /*dif= resN-resC;
    if(dif>0)   //Difference increased
    {
        myANN->updatePolicy(0,dif,0.001);    //Negative update
    }else if(dif<0)
    {
        myANN->updatePolicy(0,dif,0.001);    //Positive update
    }
    // Updating the policy if the value has increased (the difference between the target and the value is smaller)
    */
    //if((resN-resC)>0)
    //{
        //myANN->updatePolicy(0,dif,0.01);
    //}
       // if( x>4 && x<6)
         //   cout <<x<<":resN:"<<resN<<":resC:"<<resC<<":dif:"<<dif<<" Pol="<<pol << endl;
       // old=resN;
}
double testANN::cross(double x)
{
    //-(2*cos(1/x^2))/x+2*x*sin(1/x^2)
    double aux;

    aux = (-2*cos(1/(x*x)))/x + 2*x*sin(1/(x*x));
    return aux;
}

double testANN::func2(double x)
{
    return 2*x;
}
double testANN::func3(double x)
{
    return sin(x);
}
double testANN::func4(double x)
{
    return 3*x;
}
double testANN::gauss(double x)
{
    double res;

   // res = 
    return 0;
}

/*double testANN::getDifference()
{
    return 0;
}*/
double testANN::getValue()
{
    return myANN->getValue();
}
void testANN::plot()
{
    myANN->plotDif();
}
double testANN::gaussianGenerator(double mu, double sigma)
{
    double x1, x2, w, y1, y2, r1, r2;
    ofstream myfile;
    
    myfile.open("randoms.txt", ios::out|ios::app);

         do {
                r1 = randDouble(0.0,1.0);
                r2 = randDouble(0.0,1.0);
                //cout << "r1=" << r1 << " r2=" << r2 <<endl;
                x1 = 2.0 * r1 - 1.0;
                x2 = 2.0 * r2 - 1.0;
                w = x1 * x1 + x2 * x2;
         } while ( w >= 1.0 );

         w = sqrt( (-2.0 * log( w ) ) / w );
         y1 = x1 * w;
         //y2 = x2 * w;
    y1 = sigma*y1 + mu;
    
    myfile << y1 << endl;
    myfile.close();
    return y1;
}

double testANN::randDouble(double low, double high)
{
    double temp;

    /* swap low & high around if the user makes no sense */
    if (low > high)
    {
        temp = low;
        low = high;
        high = temp;
    }

    /* calculate the random number & return it */
    temp = (rand() / (static_cast<double>(RAND_MAX) + 1.0))
    * (high - low) + low;
    return temp;
}