#include <cstdlib>
#include <iostream>
#include "EADouble.h"
#include <float.h>

#define INIT_RANGE 10

using namespace std;

EADouble::EADouble()
{
	EADouble(10);
}

EADouble::EADouble(unsigned int size)
{
  for (unsigned int i=0;i<size;i++) {
    genotype.push_back(0.0);
  }
  
  randomize();
}

void EADouble::randomize(void)
{
	for (unsigned int i=0;i<genotype.size();i++) {
		genotype[i] = ((double)rand()/RAND_MAX - 0.5) / 3;
	}
}

/*
  Implementasjon av  "Swingometer crossover and mutation operator",
  Max+Delta <= Ru - Ai
  Max-Delta <= Ai - Rl
  delta = rand(Max-Delta, Max+Delta)
  Ai +/i delta
 */
void EADouble::mutate(double p)
{
  for (unsigned int i=0;i<genotype.size();i++) {
    if ( ((double)rand()/RAND_MAX) < p ) {
      bool pos = rand() % 2 == 0;
      double maxPosDelta = DBL_MAX - genotype[i];
      double maxNegDelta = DBL_MIN - genotype[i];
      bool theDecider = rand() / RAND_MAX * (unsigned int) ((-1 * maxNegDelta) + maxPosDelta) + maxNegDelta;
      genotype[i] = theDecider;
    }
  }
}

EADouble* EADouble::randomCrossover(EADouble* a, EADouble* b){
  EADouble* c = new EADouble(a->size());

  for(int i=0;i<c->size();i++){
    bool flip = rand() % 2 == 0;
    c->double_list()[i] = flip ? a->double_list()[i] : b->double_list()[i];
  }

  return c;
}

EADouble* EADouble::oneStepCrossover(EADouble* a, EADouble* b){
  int point = rand() % a->size();
  EADouble* c = new EADouble(a->size());
  for(int i=0;i< c->size();i++){
    double next = i <= point ? a->double_list()[i] : b->double_list()[i];
    c->double_list().push_back(next);
  }
  return c;
}


EAIndividual* EADouble::crossover(EAIndividual *g)
{
  EADouble *a = dynamic_cast<EADouble*>(g);
  return dynamic_cast<EAIndividual*>(randomCrossover(this, a));
}

void EADouble::print(void)
{
	for (unsigned int i=0;i<genotype.size();i++) {
		cout << genotype[i] << "-";
	}
	cout << "F="<< getFitness() << endl;
}

int EADouble::size(){
  return this->genotype.size();
}
