#ifndef EADOUBLE_H
#define EADOUBLE_H

#include <vector>
#include "EAIndividual.h"

class EADouble: public EAIndividual
{
private:
  std::vector<double> genotype;
  EADouble* randomCrossover(EADouble* a, EADouble* b);
  EADouble* oneStepCrossover(EADouble* a, EADouble* b);

public:
	EADouble();
	EADouble(unsigned int size);
	
	std::vector<double> &double_list() {return genotype;};

	EAIndividual *copy(void) {
		return new EADouble(*this);
	};
	
	void randomize(void);
	void mutate(double p);
	EAIndividual *crossover(EAIndividual *g);
	void print(void);
	int size();
};

#endif
