#ifndef EAINDIVIDUAL_H
#define EAINDIVIDUAL_H

#include <stdint.h>

class EAIndividual {

private:
	double fitness;
public:

	EAIndividual(){
		fitness = 0;
	};
	
	double getFitness() const {return fitness;};
	void setFitness(double fitness) {this->fitness = fitness;};

	virtual EAIndividual *copy(void) = 0;
	virtual void randomize(void) = 0;
	virtual void mutate(double p) = 0;
	virtual EAIndividual *crossover(EAIndividual *g) = 0;
	virtual void print(void) {};

	bool operator > (const EAIndividual &ind) {
		return (this->fitness > ind.getFitness());
	}

	bool operator < (const EAIndividual &ind) {
		return (this->fitness < ind.getFitness());
	}	
};

#endif
