#ifndef EAPOPULATION_H
#define EAPOPULATION_H

#include <algorithm>
#include "EAIndividual.h"
#include <vector>

class EAPopulation{

private:
	std::vector<EAIndividual*> individual;

public:
	EAPopulation();
	~EAPopulation();

	EAIndividual *at(unsigned int n) {return individual.at(n);};
	unsigned int size() { return individual.size(); };
	void clear(void) { individual.clear(); };
	void shrinkTo(unsigned int n) { 
		if (n >= individual.size()) return;
		individual.resize(n);
	};	

	void push(EAIndividual *ind){
		//Create a copy:
		EAIndividual *new_individual = ind->copy();
		//Push to vector:
		individual.push_back(new_individual);
	};
	
	void remove(unsigned int n) {
	};		

	unsigned int best();
	EAIndividual *getBest(){ return individual.at(best()); };
	static bool larger(EAIndividual *ind0, EAIndividual *ind1) {
		return (*ind0 > *ind1);
	};

	void sort(void){ std::sort(individual.begin(), individual.end(), larger); };
	double average(void);
	double std(void);
	void print(void);
	
	/* Operators */

	EAIndividual* operator[] (unsigned int n) {
		return individual.at(n);
	};

};

#endif
