#ifndef EAPROBLEM_H
#define EAPROBLEM_H

#include "EAScaling.h"
#include "EAPopulation.h"
#include "EAIndividual.h"

class EAProblem
{
private:
	unsigned int num_adults;
	unsigned int num_childs;
	unsigned int num_elites;
	
	unsigned int generation;
		
	double p_crossover;
	double p_mutation;

	EAScale *scaling;

	unsigned int wheel_spin(const vector<double>&);

public:
	EAPopulation population;

	EAProblem();
	virtual ~EAProblem();

	double getMutation() {return p_mutation;};
	void setMutation(double p) { p_mutation = p;};
	
	double getCrossover() {return p_crossover;};
	void setCrossover(double p) { p_crossover = p;};

	unsigned int getNumAdults() {return num_adults;};
	void setNumAdults(unsigned int n) {num_adults = n;};
	
	unsigned int getNumChilds() {return num_childs;};
	void setNumChilds(unsigned int n) {num_childs = n;};

	unsigned int getNumElites() {return num_elites;};
	void setNumElites(unsigned int n) {num_elites = n;};
	
	void setScaling(EAScale *s) {
		if (scaling) delete scaling;
		scaling = s;	
	};
	
	void run(long g);
	
	virtual void pop_init(void) = 0;
	virtual double calc_fitness(EAIndividual *) = 0;

};

#endif
