#ifndef EASCALING_H
#define EASCALING_H

#include <vector>
#include <cmath>
using namespace std;

class EAScale
{
private:
public:
	EAScale(){};
	virtual void scale(vector<double>&) = 0;
	static void normalize(vector<double> &list) {
		double sum = 0;
		for (unsigned int i=0;i<list.size();i++) {
			sum += list[i];
		}
		for (unsigned int i=0;i<list.size();i++) {
			list[i] /= sum;
		}
	};
};

class EAUnscaled: public EAScale
{
private:
public:
	EAUnscaled(){};
	virtual void scale(vector<double> &list) {};
};

class EASigmascaled: public EAScale
{
private:
public:
	EASigmascaled(){};
	void scale(vector<double> &list) {
		double sum = 0;
		double ssum = 0;
		for (unsigned int i=0; i<list.size(); i++) {
			sum += list[i];
			ssum += list[i]*list[i];
		}
		double avg = sum / list.size();
		double var = (ssum - 2*avg*sum + list.size()*avg*avg) / (list.size() - 1);
		double std = sqrt(var);

		for (unsigned int i=0; i<list.size(); i++) {
			list[i] = 1 + (list[i] - avg) / (2 * std);
			if (list[i] < 0) list[i] = 0;
		}
	};
};

#endif

