#ifndef EATESTVENTSTRUCT_H
#define EATESTVENTSTRUCT_H

#include "StatObject.h"
#include "Vent.h"

#define NUM_PARTS 15

//A structure built up usinge simple vent segments
class EATestVentStruct : public StatObject
{
protected:
	Vent* vents[NUM_PARTS];
	//stores the relative positions of each separate vent in the structure space
	dVector3 relPos[NUM_PARTS];
	//stores the relative rotations of each separate vent in the structure space
	dMatrix3 relRot[NUM_PARTS];

public:
	EATestVentStruct();
	
	void setPosition(dReal x,dReal y, dReal z);
	void setRotation(const dMatrix3 R);

	void addToSpace(dSpaceID);

	void addToViewer(Viewer *v);
};

#endif
