#include <iostream>
#include <ode/ode.h>

#include "Simulator.h"
#include "Controller.h"

using namespace std;

// some constants
#define STARTZ 0.2	// starting height of chassis

int main() {
	Simulator simulator(-1.5, 0, STARTZ, 0.05, true);
	while (simulator.running) {
		controllerFTL(simulator.getTrain(), simulator.getViewer());

		/* Show sensor data */
		//std::cout << "Travelled distance: " << simulator.getTrain()->getTravelledDistance() << std::endl;
		//std::cout << "Wheel distance: " << simulator.getTrain()->getWheelDistance(simulator.getTimestep()) << std::endl;
		//std::cout << "Distance from nose: " << simulator.getTrain()->getDistanceNose((dGeomID)simulator.getStaticSpace()) << std::endl;
		//std::cout << "Sonar distance measurement: " << simulator.getTrain()->getSonar((dGeomID)simulator.getStaticSpace(), 0.1) << std::endl;
		//double up, down, left, right;
		//simulator.getTrain()->getJointForces(0, &up, &down, &left, &right);
		//std::cout << up << " " << down << " " << left << " " << right << std::endl;

		/* Position camera in PIKo's head */
		double *position;
		position = (double *)simulator.getTrain()->getFirstModule()->chassis->getPosition();
		dVector3 forward;
		dBodyVectorToWorld(simulator.getTrain()->getFirstModule()->chassis->getBody(), -1, 0, 0, forward);
		simulator.getViewer()->positionCamera(position, forward);

		/* Step simulator forward */
		simulator.step();
	}
	return 0;
}
