#ifndef PIKO_MODULE
#define PIKO_MODULE

#include "Chassis.h"
#include "Wheel.h"

class PIKo_Module : public Object
{
private:
	dReal width, height, depth, chassis_mass, wheel_radius, wheel_width, wheel_mass;
public:
	Chassis *chassis;
	Wheel *r1Wheel, *l1Wheel, *r2Wheel, *l2Wheel;
	dJointID r1Joint, l1Joint, r2Joint, l2Joint;		//hinges attaching wheels to the chassis

	PIKo_Module(dWorldID world, dReal width, dReal height, dReal depth, dReal chassis_mass, dReal wheel_radius, dReal wheel_width, dReal wheel_mass); //default values for PIKo

	void setPosition(dReal x, dReal y, dReal z);
	void setRotation(const dMatrix3 R);

	void addToSpace(dSpaceID space);

	dBodyID getBody();
	const dReal * getPosition();
	const dReal * getRotation();
	dReal * getDimensions();

	void addToViewer(Viewer *v);
};
#endif
