#include "RAPrism.h"

RAPrism::RAPrism(dWorldID world)
{
	dimensions[0] = 1.0f;
	dimensions[1] = 1.0f;
	dimensions[2] = 1.0f;
	dReal mass = 1.0f;

	RAPrism(world, dimensions[0], dimensions[1], dimensions[2], mass);
}

RAPrism::RAPrism(dWorldID world, dReal width, dReal height, dReal depth, dReal mass)
{
	dimensions[0] = width;
	dimensions[1] = depth;
	dimensions[2] = height;

	body = dBodyCreate(world);
	geom = dCreateBox(0, width, height, depth);

	dMass m;
	dMassSetBox(&m, 1.0f, width, height, depth);
	dMassAdjust(&m, mass);
	dBodySetMass(body, &m);

	dGeomSetBody(geom, body);
}

dReal * RAPrism::getDimensions()
{
	return dimensions;
}

void RAPrism::addToViewer(Viewer *v) {
	////Set drawing method and add geometry to the viewer for drawing
	ISceneNode* node = v->getSceneManager()->addCubeSceneNode(1);
	dGeomSetData(geom, node);

	dReal* position = (dReal*)dGeomGetPosition(getGeom());
	node->setPosition(vector3df(position[0], position[1], position[2]));
	node->setScale(vector3df(dimensions[0], dimensions[1], dimensions[2]));

	//node->setMaterialType(EMT_TRANSPARENT_ADD_COLOR);
	node->setMaterialTexture(0, v->getVideoDriver()->getTexture("../../ode/drawstuff/textures/wood.ppm"));
	node->setMaterialFlag(video::EMF_LIGHTING, false);

	v->addObject(this->geom);
}
