#ifndef VIEWER_H
#define VIEWER_H

#include <irrlicht/irrlicht.h>
#include <ode/ode.h>
#include <vector>
#include "EventReceiver.h"

using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io; 
using namespace gui;
using namespace std;

class Object;

class Viewer {
private:
	IrrlichtDevice* device;
	IVideoDriver* driver;
	IGUIEnvironment* guienv;
	ICameraSceneNode *camera;
	ICameraSceneNode *headCamera;
	
	vector<dGeomID> geoms;

public:
	Viewer(int width, int height);
	~Viewer();
	
	void updateScene();
	void addObject(dGeomID g);
	IVideoDriver* getVideoDriver();
	ISceneManager* smgr;
	ISceneManager* getSceneManager();
	EventReceiver receiver;
	bool draw();
	void positionCamera(double *position, double *direction);
};

#endif
